package com.company.audiodemo.view.audiodemo.component;

import com.vaadin.flow.component.*;
import com.vaadin.flow.server.*;


@Tag(Audio.TAG)
public class Audio extends Component implements HasSize {

    public static final String TAG = "audio";

    public Audio() {
        getElement().setAttribute("controls", true);
/* TODO - Debugging
        getElement().getPropertyNames().forEach(str -> {
            System.out.println("Property: " + str);
        });
        getElement().getAttributeNames().forEach(str -> {
            System.out.println("Attribute: " + str);
        });
 */
    }

    public void showControls(Boolean value) {
        getElement().setProperty("controls", value);
    }

    public String getSource() {
        return getElement().getProperty("src");
    }

    public void setSource(String source) {
        getElement().setProperty("src", source);
    }

    public void setSource(final AbstractStreamResource resource) {
        getElement().setAttribute("src", resource);
    }

    public void setText(String name) {
        getElement().setText(name);
    }

    public void play() {
        getElement().callJsFunction("play");
    }

    public void pause() {
        getElement().callJsFunction("pause");
    }
}
